
	
.include "c:\atmel\avrtools\appnotes\tn26def.inc"
.list
;-     ,  ,
 
.equ Light =PA0 ;PA0 interrupt input sygnal to overvoltage
.equ SW =PA1 ;PA1 zerro cross Input sensor
.equ Led1 =PA2 ;PA2 Light Output
.equ Led2 =PA4 ;PA4 Output Led for indication
.equ Led3 =PA5 ;PA5 Output triak Led control
.def dig1 = r1;
.def dig2 = r2;
.def dig3 = r3;
.def dig4 = r4;
.def dig5 = r5;
.def cc = r0;devider if interrupt routines
.def ccc = r21; number of chennels
.def rbin1L = R10
.def rbin1H = R11
.def rbin2L = R12
.def rbin2H = R13
.def mpr = R16
.def var1 = R17
.def var2 = R18
.def var3 = R19
.def temp = r20 ;   
 
;Address Labels Code Comments
rjmp RESET ; Reset handler
rjmp EXT_INT0 ; IRQ0 handler
nop;$002 rjmp PIN_CHANGE ; Pin change handler
nop;$003 rjmp TIM1_CMP1A ; Timer1 compare match 1A
nop;$004 rjmp TIM1_CMP1B ; Timer1 compare match 1B
nop;$005 rjmp TIM1_OVF ; Timer1 overflow handler
nop; rjmp TIM0_OVF ; Timer0 overflow handler
nop;$007 rjmp USI_STRT ; USI Start handler
nop;$008 rjmp USI_OVF ; USI Overflow handler
nop;$009 rjmp EE_RDY ; EEPROM Ready handler
nop;$00A rjmp ANA_COMP ; Analog Comparator handle
nop;$00B rjmp ADC ; ADC Conversion Handler
;******************************************************
;* *
;*   *
;* *
;******************************************************
RESET: ldi r16, RAMEND ; Main program start ;   
out SP, r16;     
ldi temp,$0f;  PB
out ddrb, temp;pb 1..4 and 7 are outputs
ldi mpr,0b10111100
out DDRA,mpr
ldi mpr,0b10111110 ;non pull-up input **
out PORTA,mpr
ldi mpr,0b11100000
out PORTB,mpr
;---------------------------  () 
ldi temp, 0x80
out ACSR, temp
;---------------------------   T0
ldi temp,(1<<int0);
out gimsk,temp; set gneral interrupt control register bit 6 to enable int0
reset1: cli;disable global interrupts
clr r17;
clr r3
clr mpr;
Rcall delay500ms
rcall delay500ms
;=======================================================================
;   
;=======================================================================----------
rcall delay500ms
rcall delay500ms
ldi mpr,8; initial delay - largest, no need more than 8ms
sei;enable global interrupts
m0:mov r23,mpr; number of delays
m1: sbic pina,sw; waiting for zerro crossing
rjmp m1;
inc r17
cpi r17,150;count 2 second to step up switch triak angle
breq m2;
sbi porta,4; turn off indication LED as soon as triak must be OFF
rcall delay1ms
cbi porta,4; turn on indication LED as soon as triak must be ON
cbi porta,5; pulse to turn up light
nop
nop
nop
nop
sbi porta,5;
rjmp m0;repeat 200 times
m2: clr r17
dec mpr;
brne m0;; dimmering is finished
m4:sbic pina,sw; waiting for zerro crossing
rjmp m4;all lamps are ON
sbi porta,4; turn off indication LED as soon as triak must be OFF
ldi r23,1;
cpi var2,230;
brlo z1; go to z1 if negative
rcall delay1ms;
z1: ldi r23,1;
rcall delay1ms;
clc;
cbi porta,4; turn on indication LED as soon as triak must be ON
cbi porta,5; pulse to turn up light
nop
nop
nop
nop
sbi porta,5;
rcall readadc0;
rjmp m4;
 
EXT_INT0: ;interrupt 0 handling..
;push sreg;
sbi porta,5
sbi porta,4; turn off indication LED as soon as triak must be OFF
cbi porta,2; to fix up overvoltage with red LED on PA2
rjmp reset1;
;pop sreg
reti;
 
readadc0:;Read ADC (ch0)
ldi mpr,0b10100000 ;set ADMUX int ref ch0? data is left adjusted
out ADMUX,mpr
rcall readadc;rbin1L
mov mpr,rbin1H
mov var2,mpr
ret;
 
readadc: ldi temp,0b11000010;, , 1:4
out ADCSR,temp
in mpr,ADCL
mov rbin1L,mpr
in mpr,ADCH
mov rbin1H,mpr
ret


;Delay 500ms @8mhz
delay500ms: push R23
push R24
push R25
ldi R23,0x6B
_wg500loop0: ldi R24,0x46
_wg500loop1: ldi R25,0xB1
_wg500loop2: dec R25
brne _wg500loop2
dec R24
brne _wg500loop1
dec R23
brne _wg500loop0
pop R25
pop R24
pop R23
ret
 
;Delay 5ms @8mhz
delay1ms:; push R23
push R24
push R25
;ldi R23,0x1
_wg5loop0: ldi R24,0x16;
_wg5loop1: ldi R25,0x10; was xb1
_wg5loop2: dec R25
brne _wg5loop2
dec R24
brne _wg5loop1
dec R23
brne _wg5loop0
pop R25
pop R24
; pop R23
ret
 
;***************************************************
